From da2558ec92bfd5c2ec2008f02e522b1fb97ef7d0 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 26 2020 01:16:14 +0000
Subject: [PATCH 1555/2232] Reject array containing &str or &[u8] for now


This is blocked on making slices' data() and size() call into Rust to
deconstruct the fat pointer, which is TODO.

---

diff --git a/syntax/check.rs b/syntax/check.rs
index 6ffdbb1..fcce5d4 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -186,7 +186,12 @@ fn check_type_slice(cx: &mut Check, ty: &Slice) {
 }
 
 fn check_type_array(cx: &mut Check, ty: &Array) {
-    if is_unsized(cx, &ty.inner) {
+    let supported = match &ty.inner {
+        Type::Str(_) | Type::SliceRefU8(_) => false,
+        element => !is_unsized(cx, element),
+    };
+
+    if !supported {
         cx.error(ty, "unsupported array element type");
     }
 }

